#encoding: UTF-8

module Etti
    class Page
        # all metrics in mm
        def initialize *ag
            args = ag.extract_args!

            @name = args[:name] || ''
            # the manufacture of the labels
            @manufacture = args[:manufacture] || ''
            # the original order number
            @orderNr = args[:orderNr] || ''
            # a longer description of the labels
            @description = args[:description] || ''
            @pageSize = args[:pageSize] || 'a4'
            @cols = args[:cols] || 10
            @rows = args[:rows] || 28
            # size of a single label
            # one value = circular labels = diameter
            # two values = rectangle labels = width x height
            @size = args[:size] || [20.0, 10.0]
            # left, top; we asume, that left, right and top, bottom are equal
            @borders = args[:borders] || [5.0, 7.0]
            # borders between labels; horizontal, vertical
            @padding = args[:padding] || [0.0, 0.0]
        end

        attr_accessor :name, :manufacture, :orderNr, :description
        attr_accessor :pageSize, :cols, :rows, :size, :borders, :padding


#        def margins_valid?
#            ps = @pageSizes[@pageSize]
#            raise ArgumentError, 'invalid page size ' + @pageSize.to_s if ps.nil?
#            ps[0] >= @borders[0] + @cols * @size[0] + (@cols -1) * @padding[0] and
#                ps[1] >= @borders[1] + @cols * @size[1] + (@cols -1) * @padding[1]
#        end
    end
end
