module Etti
    DATA_PATH = File.expand_path(File.dirname(__FILE__) + '/../lib/data') + '/'
    PIXMAP_PATH = DATA_PATH + 'pixmaps/'
    LOCALE_PATH = DATA_PATH + 'locale/'
end


require 'fileutils'
require 'cairo'
require 'gettext'
require 'gtk3'
require 'json'
require 'qrencoder'
require 'filemagic'

require 'rgw/big-list'
require 'rgw/pile'
require 'rgw/property-editor'
require 'rgw/radio-revealer'
require 'rgw/restricted-entry'

require 'etti/colors'
require 'etti/dnd-data'
require 'etti/page-datas'
require 'etti/print-view'

require 'etti/monkeys/array'
require 'etti/monkeys/cairo-context'
require 'etti/monkeys/gtk-event-box'

require 'etti/elements/base'
require 'etti/elements/text'
require 'etti/elements/data'

require 'etti/file/data-reader'

require 'etti/ui/data-page'
require 'etti/ui/label-elements'
require 'etti/ui/label-layout'
require 'etti/ui/label-layout-page'
require 'etti/ui/label-selection-page'
require 'etti/ui/message-dialog'
require 'etti/ui/page-layout'
require 'etti/ui/property-editor-data'
require 'etti/ui/window'
